/* Teil von RandomXmas v1.1 zu Weihnachten 2001 
 * Frei kopierbar, aber nur vollstndig mit diesem Spiel.c und Makefile und 
 * readme.txt. Vernderungen mglich, bei Weitergabe aber immer Original 
 * hiervon und Spiel.c mit beilegen,		
 * Keine Patentierungen auf Teile des oder ganzes Programm(s)*/

#include <GL/glut.h>
#include <sys/time.h>
#include <sys/timeb.h>
#include <stdlib.h>

#include "ebenefeld.h"

//---Klasse Feld-----------------------------------------

Feld::Feld(feldtyp neutyp, int neuhoehe, int neudarunter, int neudarueber)
{
  this->typ = neutyp;
  this->hoehe = neuhoehe;
  this->darunter = neudarunter;
  this->darueber = new GrafikAusgabe(0, 0, 0, neudarueber);
  this->darueber->SetSize(MAXFELD/3);
  this->textoben[1] = '\0';
  this->textoben[0] = (neudarueber % 26) + 64;
  this->darueber->SetText( textoben );
  this->darueber->SetColor(0.5, 0.5, 1.0);
  qfeld = gluNewQuadric();
}

Feld::~Feld()
{
  this->typ = typlos;
  this->hoehe = 0;
  this->darunter = 0;
  delete darueber;
  gluDeleteQuadric(qfeld);
};

void Feld::Change(feldtyp neutyp, int neuhoehe, int neudarunter)
{
  this->typ = neutyp;
  if (neuhoehe > 0) this->hoehe = neuhoehe;
  this->darunter = neudarunter;
}

int Feld::Leeren()
{
  int erg;

  erg = this->darunter;
  this->darunter = 0;
  if (this->typ == huegel)
    if (this->hoehe <= MAXFELDHOEHE/2)
      erg = 0;			//Huegel zu klein
  return erg;
};

int Feld::GetDarueber()
{
  int x, erg=0;

  x = this->darueber->GetWert();
  if  (x <   8) erg = erg + 500;
  if ((x >=  4) && (x <  8)) erg = erg + 99;
  if ((x >=  8) && (x < 13)) erg = erg + 22;
  if ((x >= 13) && (x < 18)) erg = erg + 44;
  if ((x >= 18) && (x < 22)) erg = erg + 22;
  if  (x >= 18) erg = erg + 2000;
  if  (x ==  0) erg = 0;
  this->darueber->SetWert(0);
  this->darueber->SetText(" ");
  return erg;
};

feldtyp Feld::GetTyp()
{
  return this->typ;
}

void Feld::DrawFeld(int x, int y)
{
  GLfloat baum_amb[] = {0.3, 0.3, 0.3}, light_null[] = {0.4, 0.4, 0.4};
  GLfloat baum_dif1[] = { 0, 0.5, 0 }, baum_dif2[] = { 0, 0.3, 0 };
  GLfloat huegel_amb1[] = { 0.85, 0.85, 1 }, huegel_amb2[] = { 0.75, 0.75, 0.75 };
  GLfloat huegel_spec[] = { 0.8, 0.8, 0.8 };

  glPushMatrix();
  glTranslatef(x*2, 0, y*2);	//y -> z
  glRotatef(-90, 1, 0, 0);
  if (this->typ == baum) 
    if ((this->darunter == 0) && (EINFACH > 0)) glColor3f(0, 0.5, 0);
      else glColor3f(0, 0.3, 0);
  if (this->typ == baum) 
    glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, baum_amb);
  if (this->typ == baum) 
    if ((this->darunter == 0) && (EINFACH > 0)) 
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, baum_dif1);
      else glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, baum_dif2);
  if (this->typ == huegel)
    if ((this->darunter == 0) && (EINFACH > 0)) glColor3f(0.85, 0.85, 1);
     else glColor3f(0.85, 0.85, 0.85);
  if (this->typ == huegel)
    if ((this->darunter == 0) && (EINFACH > 0)) 
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, huegel_amb1);
     else glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, huegel_amb2);
  if (this->typ == huegel)
     glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, huegel_spec);
  if (this->typ != typlos)
    if (hoehe < 4)
      gluCylinder(qfeld, 0.6, 0.4, (this->hoehe - 1)*FELDEINHEIT, 10, 5);
    else
      gluCylinder(qfeld, 1, 0.4, (this->hoehe - 1)*FELDEINHEIT, 10, 5);

  glTranslatef(0, 0, (this->hoehe - 1)*FELDEINHEIT);
  if (this->typ == huegel) gluSphere(qfeld, 0.4, 10, 10);
  if (this->typ == baum) gluCylinder(qfeld, 0.4, 0, 2*FELDEINHEIT, 10, 5);
  glTranslatef(0, 0, -(this->hoehe - 1)*FELDEINHEIT);
  
  glTranslatef(0, 0, 14*FELDEINHEIT);
  glRotatef(90, 1, 0, 0);
  if (darueber->GetWert() ) darueber->DrawAusgabe();
  glRotatef(-90, 1, 0, 0);
  glTranslatef(0, 0, -14*FELDEINHEIT);
  
  glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, light_null);
  glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, light_null);
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, light_null);
  glPopMatrix();
}

//---Klasse Ebene-------------------------------------

Ebene::Ebene(int neunummer)
{
  int 	  x,y, neuhoehe, anzunten, anzoben, r1, r2;
  feldtyp neutyp;
  struct timeval  tv;
  struct timezone tz;

  gettimeofday(&tv, &tz);			//init Zufallsgenerator
  srand(tv.tv_sec % 65536);
  
  for(y=0; y<=MAXFELD-1; y++)
    for(x=0; x<=MAXFELD-1; x++)
      {
	r1 = rand()% 3; r2 = rand() % 3;
	if (r1 == 0) neutyp = huegel;
	        else neutyp = baum;
	r1 = (rand() % MAXFELDHOEHE/2)+1;
	if (neutyp == baum) neuhoehe = r1*2;
	   else if (r2 == 0) neuhoehe = r1;
	          else neuhoehe = MAXFELDHOEHE/2 + r1;
	r1 = (rand() % MAXFELDHOEHE);
	r2 = (rand() % MAXFELDHOEHE);
	anzunten = (r1*10 + r2);
	r1 = rand() % (MAXFELD*MAXFELD);
	r2 = rand() % 26;
	if (r1 < MAXFELD) anzoben = r2; else anzoben=0;
	if (y*MAXFELD + x == neunummer % ( MAXFELD*MAXFELD) ) 
	  anzunten = anzunten + 2000;
        if (neutyp == huegel) anzunten = anzunten % (MAXEBENEN-1);
	this->felder[x][y] = new Feld(neutyp, neuhoehe, anzunten, anzoben);
      };
  fahrstuhl=0;  
  nummer = new GrafikAusgabe( 3*MAXFELD/2, 3*MAXFELD, 0, neunummer);
  nummer->SetSize(MAXFELD/2);
  nummer->SetColor(1.0, 0.0, 1.0);
  zeile = new GrafikAusgabe( 0*MAXFELD, 3*MAXFELD, 0, 0);
  zeile->SetSize(MAXFELD/3);
  zeile->SetText("Ebene");
  zeile->SetColor(1.0, 0.0, 1.0);
}

Ebene::~Ebene()
{
  int x,y;

  for(y=0; y<=MAXFELD-1; y++)
    for(x=0; x<=MAXFELD-1; x++)
      delete this->felder[x][y];
  delete nummer;
}

int Ebene::IstDortBaum(int x, int y)
{
  int feldx, feldy, erg=-1;     //0-99:Baum mit Geschenkanz,
				// -1: leer, -2..-101: Huegel

  if ((abs(x % 2) == 1) && (abs(y % 2) == 1))  
		//sonst kein EbenenFeld dort
    { 
      feldx = (x-1+MAXFELD)/2;   //siehe auch DrawEbene
      feldy = (y-1+MAXFELD)/2;
      if ((feldx >= 0) && (feldx < MAXFELD))
        if ((feldy >= 0) && (feldy < MAXFELD))
	  {
		if (this->felder[feldx][feldy]->GetTyp() == baum)
		  erg = this->felder[feldx][feldy]->Leeren();
		if (this->felder[feldx][feldy]->GetTyp() == huegel)
		  erg = -((this->felder[feldx][feldy]->Leeren()) + 2);
    	  };
    };
  return erg;
}

int Ebene::GetDarueber(int x, int y)
{
  int feldx, feldy, erg= 0;

  if ((abs(x%2) == 1) && (abs(y % 2) == 1))	
	//sonst kein EbenenFeld dort
    {
	feldx = (x-1+MAXFELD)/2;
	feldy = (y-1+MAXFELD)/2;
        if ((feldx >= 0) && (feldx < MAXFELD))
          if ((feldy >= 0) && (feldy < MAXFELD))
	    erg = this->felder[feldx][feldy]->GetDarueber();
    };	
  return erg;
};

void Ebene::TrigFahrstuhl()
{
  if (this->fahrstuhl == 1) this->fahrstuhl=0;
    else this->fahrstuhl=1;
}

void Ebene::DrawEbene()
{
  GLfloat ebene_amb[] = {0.85, 0.85, 0.85};
  int x,y, s;

  s=MAXFELD*2+1;
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, ebene_amb);
  glBegin(GL_POLYGON);
    glColor3f(1.0, 1.0, 1.0);
    glVertex3f(-s, 0, s);
    glVertex3f(s, 0, s);
    glVertex3f(s, 0, -s);
    glVertex3f(-s, 0, -s);
    glVertex3f(-s, 0, s);
  glEnd();
  nummer->DrawAusgabe();
  zeile->DrawAusgabe();
  if (this->fahrstuhl == 0)
    for(y=0; y<=MAXFELD-1; y++)
      for(x=0; x<=MAXFELD-1; x++)
        this->felder[x][y]->DrawFeld(x*2+1-MAXFELD, y*2+1-MAXFELD);
}

