/* RandomXmas v1.1 zu Weihnachten 2001 
 * Frei kopierbar, aber nur vollstndig mit diesem Spiel.c und Makefile und 
 * readme.txt. Vernderungen mglich, bei Weitergabe aber immer Original
 * Spiel.c mit beilegen,		
 * Keine Patentierungen auf Teile des oder ganzes Programm(s)*/
// Joystick nicht getestet !
//***Vereinbarungen****************************
//---Includes, Konstanten----------------------

#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/timeb.h>
#include <string.h>

#include "mann.h"
#include "ebenefeld.h"
#include "konstanten.h"

//---Typen- und Klassendefiniton----------------

class Highscoreboard
  {
	public:
		Highscoreboard();
		~Highscoreboard();
		void DrawBoard();
	private:
		void Readfile();
		void Writefile();
		int imax;
   		char punktstring[100];
   		char *scorefeld[1000];
		GrafikAusgabe *topten[13];
  };
	
//--- globale Variablen -----------------------

int		aktxwinkel, aktywinkel, aktzwinkel;
float		aktxtrans, aktytrans, aktztrans;
int 		aktwidth, aktheight;
int 		trans=0, winkel=1, reshape=0;
int		joystickx, joysticky;
char		*highscorefile=0, *vorname=0, *nachname=0;

Spielraumtyp	*spraum;
Mann		*weihmann;		
Highscoreboard  *highscore;

//***Methoden der Klassen*************************

//--- Klasse Highscoreboard ----------------------

Highscoreboard::Highscoreboard()
{
   int i;

   imax = 0;
   for(i=0;i<1000;i++) scorefeld[i] = NULL;
   for(i=0;i< 100;i++) punktstring[i] = ' ';
   for(i=0;i<  12;i++) topten[i] = NULL;
   Readfile();
};

   
Highscoreboard::~Highscoreboard()
{
   int i;

   Writefile();
   for(i=0;i<1000;i++) 
     if (scorefeld[i]) delete[] scorefeld[i];
   for(i=0;i<  12;i++) delete topten[i];
};

void Highscoreboard::Readfile()
{
   struct timeb tp;
   char zeit[24];
   int	i=0, highpunkte;
   FILE *fpr;
   char zeile[100];

   sprintf(punktstring, "%d ", spraum->punkte);
   i=ftime(&tp);
   strncpy(zeit, ctime(&tp.time), strlen(ctime(&tp.time)) + 1 );
   strncat(punktstring, zeit, strlen(zeit) - 1);
   strcat(punktstring, " ");
   if (vorname) strcat(punktstring, vorname);
   strcat(punktstring, " ");
   if (nachname) strcat(punktstring, nachname);
   strcat(punktstring, "\n");
   if (highscorefile) fpr = fopen(highscorefile, "a+");
     else fpr = NULL;
   if (fpr) 
     {
	rewind(fpr);
	i = 0;
	if (fpr) 
          while ((i < 1000) && (fgets(zeile, 100, fpr)))
           {
		if (strlen(zeile) > 2) 
		  {
			scorefeld[i] = new char[ strlen(zeile) + 1 ];
			strcpy(scorefeld[i], zeile);
			i = i + 1;
		  };
	  	imax = i;
           }
	fclose(fpr);
     }
   i=0;
   topten[0] = new GrafikAusgabe(-4*MAXFELD, MAXFELD*4, -5*MAXFELD/2, 0);
   topten[0]->SetSize(MAXFELD/3);
   topten[0]->SetText("Die besten Zehn");
   topten[0]->SetColor(1.0, 1.0, 1.0);
   while (i < 10)
     {
	topten[i+1] = new GrafikAusgabe(-4*MAXFELD, MAXFELD/2*(7 - i ), -5*MAXFELD/2, 0);
	topten[i+1]->SetSize(MAXFELD/3);
	if (i < imax) topten[i+1]->SetText(scorefeld[i]);
	  else topten[i+1]->SetText("");
	topten[i+1]->SetColor(1.0, 1.0, 1.0);
	i = i + 1;
     }
   topten[11] = new GrafikAusgabe(-4*MAXFELD, -MAXFELD*3/2, -5*MAXFELD/2, 0);
   topten[11]->SetSize(MAXFELD/3);
   topten[11]->SetText("Deine Punkte");
   topten[11]->SetColor(1.0, 1.0, 1.0);
   topten[12] = new GrafikAusgabe(-4*MAXFELD, -MAXFELD*2, -5*MAXFELD/2, 0);
   topten[12]->SetSize(MAXFELD/3);
   topten[12]->SetText(punktstring);
   topten[12]->SetColor(1.0, 1.0, 1.0);
};

void Highscoreboard::Writefile()
{
   int	i=0, highpunkte;
   FILE *fpr;
   char zeile[100];

   i=0;
   fpr = fopen(highscorefile, "w");
   if (fpr)
     {
	if (imax > 0) highpunkte = strtol(scorefeld[i], (char **)NULL, 10);
	  else highpunkte = -1;
   	i=0;
   	while ( (highpunkte > spraum->punkte) && (i < imax) )
     	  {
		fprintf(fpr, scorefeld[i++]);
		fprintf(fpr, "\n");		
		if (scorefeld[i]) highpunkte = atoi(scorefeld[i]);
		  else highpunkte = 0; 	
     	  };
   	fprintf(fpr, punktstring);
   	fprintf(fpr, "\r\n");		//Dos-Kompatibel
   	while (i < imax) 
     	  {
		fprintf(fpr, scorefeld[i++]);
		fprintf(fpr, "\n");		
     	  }	
   	fclose(fpr);
     }
    else 
     { 
	printf(punktstring);
	printf("\r\n");			//Dos-Kompatibel
     } 
};

void Highscoreboard::DrawBoard()
{
   int i;

   for(i=0;i<=12;i++)
	if (topten[i]) topten[i]->DrawAusgabe();
};

//***Funktionen, OpenGL-Grundlagen***********************

void initVars()
{
  aktxwinkel = 0; aktywinkel = 0; aktzwinkel = 0;
  aktxtrans = 0; aktytrans = 0; aktztrans = 0;
  aktwidth = ANFWIDTH; aktheight = ANFHEIGHT;
  spraum = new Spielraumtyp;
  spraum->aktebene = 1; spraum->punkte = 0; spraum->ende = 0;
  spraum->spielraum[spraum->aktebene - 1] = 
			new Ebene(spraum->aktebene-1);
  spraum->raumused[spraum->aktebene - 1 ] = 1;
  weihmann = new Mann(3, 0.6);
};

//---Ende + Darstellungsfunktion, greift auf die Klassen zu-------

void endeproc()
{ 
   int i;

   delete highscore;
   for(i=0; i <= MAXEBENEN-2; i++)
     {
	if ( spraum->raumused[i] > 0 ) delete spraum->spielraum[i];
	spraum->raumused[i] = 0;
     };
   delete weihmann;
   delete spraum;
   exit(0);
}

void display(void)
{  
  glEnable(GL_DEPTH_TEST);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glPushMatrix();
  if (spraum->ende == 1) aktxwinkel = -30;
  glTranslatef(aktxtrans/10, aktytrans/10, aktztrans/10);
  glRotatef(aktxwinkel, 1, 0, 0);
  glRotatef(aktywinkel, 0, 1, 0);
  glRotatef(aktzwinkel, 0, 0, 1);

  if (spraum->ende == 0) 
	spraum->spielraum[spraum->aktebene-1]->DrawEbene();
  if (spraum->ende == 0) weihmann->DrawMann();
  if (spraum->ende == 1) if (!highscore) highscore = new Highscoreboard(); 
		 	   else highscore->DrawBoard();
  if (spraum->ende == 2) endeproc();
  
  glFlush();
  glPopMatrix();
}

//---Einstellungen fr Darstellung-----------------------------

void init (void)
{
   GLfloat light_amb[] = {0.6, 0.6, 0.6}, light_null[] = { 0.4, 0.4, 0.4 };

   glClearColor (0.0, 0.0, 0.0, 0.0);
   glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);

   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluPerspective(60, 1, 1, 15*MAXFELD);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
   gluLookAt(0, MAXFELD*7/2, MAXFELD*5, 0, MAXFELD, 0, 0, 1, 0);

   glLightModelfv(GL_LIGHT_MODEL_AMBIENT, light_amb);
   glEnable(GL_LIGHT0);
   glEnable(GL_LIGHTING);
   glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, light_null);
   glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, light_null);
   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, light_null);
}

void DoReshape(int width, int height)
{
   int minsize, maxsize;

   aktwidth = width; aktheight = height;
   if (width >= height) { minsize = height; maxsize = width; }
     else { minsize = width; maxsize = height; };
   
   glViewport(0, 0, width, height);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluPerspective(60*maxsize/minsize, 1, 1, 15*MAXFELD);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
   gluLookAt(0, MAXFELD*7/2, MAXFELD*5, 0, MAXFELD, 0, 0, 1, 0);
}

//---Tastatur-Eingabeverarbeitung-----------------------------

static void joystickfunc(unsigned int buttonMask, int x, int y, int z)
{
  short xl, yl, xr, yr, xu, yu, xd, yd, wl, wr, wu, wd;
  int	movex, movey;

  if ((aktywinkel <= 45) || (aktywinkel > 315))
    { xl=-1; yl=0; xr=1; yr=0; xu=0; yu=-1; xd=0; yd=1;
 	wl=90; wr=270; wu=0; wd=180;};
  if ((aktywinkel > 45) && (aktywinkel <= 135)) 
    {xl=0; yl=-1; xr=0; yr=1; xu=1; yu=0; xd=-1; yd=0;
	wl=0; wr=180; wu=270; wd=90; };
  if ((aktywinkel > 135) && (aktywinkel <= 225)) 
    {xl=1; yl=0; xr=-1; yr=0; xu=0; yu=1; xd=0; yd=-1;
	wl=270; wr=90; wu=180; wd=0; };
  if ((aktywinkel > 225) && (aktywinkel <= 315))
    {xl=0; yl=1; xr=0; yr=-1; xu=-1; yu=0; xd=1; yd=0;
	wl=180; wr=0; wu=90; wd=270; }; 
  
  movex = x - joystickx;				//Pos-Differenz
  movey = y - joysticky;
  if ( movex >= movey) movey = 0; else movex = 0;	//nicht diagonal
  if (buttonMask & GLUT_JOYSTICK_BUTTON_A)
	weihmann->AddPos(spraum, 0, 0, 1);
  if (movex < 10) { weihmann->AddPos(spraum, xl, yl, 0); 	//Links
	weihmann->NeuRichtung(wl); };
  if (movex > 10) { weihmann->AddPos(spraum, xr, yr, 0); 	//Rechts
	weihmann->NeuRichtung(wr); };
  if (movey < 10) { weihmann->AddPos(spraum, xu, yu, 0);	//Unten
	weihmann->NeuRichtung(wu); };
  if (movey > 10) { weihmann->AddPos(spraum, xd, yd, 0);	//Oben
	weihmann->NeuRichtung(wd); };
  joystickx = x; joysticky = y;
  glutPostRedisplay();
}

static void specialkey(int key, int x, int y)
{
  short xl, yl, xr, yr, xu, yu, xd, yd, wl, wr, wu, wd;

  if ((aktywinkel <= 45) || (aktywinkel > 315))
    { xl=-1; yl=0; xr=1; yr=0; xu=0; yu=-1; xd=0; yd=1;
 	wl=90; wr=270; wu=0; wd=180;};
  if ((aktywinkel > 45) && (aktywinkel <= 135)) 
    {xl=0; yl=-1; xr=0; yr=1; xu=1; yu=0; xd=-1; yd=0;
	wl=0; wr=180; wu=270; wd=90; };
  if ((aktywinkel > 135) && (aktywinkel <= 225)) 
    {xl=1; yl=0; xr=-1; yr=0; xu=0; yu=1; xd=0; yd=-1;
	wl=270; wr=90; wu=180; wd=0; };
  if ((aktywinkel > 225) && (aktywinkel <= 315))
    {xl=0; yl=1; xr=0; yr=-1; xu=-1; yu=0; xd=1; yd=0;
	wl=180; wr=0; wu=90; wd=270; }; 
  
  switch (key) {
     case GLUT_KEY_END	 : weihmann->AddPos(spraum, 0, 0, 1); break;
     case GLUT_KEY_LEFT  : weihmann->AddPos(spraum, xl, yl, 0); 
			     weihmann->NeuRichtung(wl); break;
     case GLUT_KEY_RIGHT : weihmann->AddPos(spraum, xr, yr, 0); 
			     weihmann->NeuRichtung(wr); break;
     case GLUT_KEY_UP    : weihmann->AddPos(spraum, xu, yu, 0);
			     weihmann->NeuRichtung(wu); break;
     case GLUT_KEY_DOWN  : weihmann->AddPos(spraum, xd, yd, 0);
			     weihmann->NeuRichtung(wd); break;
     }
   glutPostRedisplay();
}

static void key(unsigned char k, int x, int y)
{
  switch (k) {
     case 'v' : trans=1; winkel=0; reshape=0; break;
     case 'd' : winkel=1; trans=0; reshape=0; break;
     case 'r' : reshape=1; trans=0; winkel=0; break;
     case 'p' : weihmann->TriggerPunktAnz(); break;
     case 27  : spraum->ende = spraum->ende + 1; break;
     }
  if (winkel)
   switch (k) {
     case 'x' : aktxwinkel = (aktxwinkel + 30) % 360; break;
     case 'X' : aktxwinkel = (aktxwinkel - 30) % 360; break;
     case 'y' : aktywinkel = (aktywinkel + 30) % 360; break;
     case 'Y' : aktywinkel = (aktywinkel - 30) % 360; break;
     case 'z' : aktzwinkel = (aktzwinkel + 30) % 360; break;
     case 'Z' : aktzwinkel = (aktzwinkel - 30) % 360; break;     
     case 'i' : aktxwinkel = 0; aktywinkel = 0; aktzwinkel = 0; break; 
   }
  if (trans)
   switch (k) {
     case 'x' : aktxtrans = (aktxtrans + 1) ; break;
     case 'X' : aktxtrans = (aktxtrans - 1) ; break;
     case 'y' : aktytrans = (aktytrans + 1) ; break;
     case 'Y' : aktytrans = (aktytrans - 1) ; break;
     case 'z' : aktztrans = (aktztrans + 1) ; break;
     case 'Z' : aktztrans = (aktztrans - 1) ; break;     
     case 'i' : aktxtrans = 0; aktytrans = 0; aktztrans = 0; break;
    }
  if (reshape)
    switch (k) {
     case 'x' : aktwidth = (aktwidth + 10) ; break;
     case 'X' : if (aktwidth>10) aktwidth = (aktwidth - 10) ; break;
     case 'y' : aktheight = (aktheight + 10) ; break;
     case 'Y' : if (aktheight>10) aktheight = (aktheight - 10) ; break;    
     case 'i' : aktwidth = ANFWIDTH; aktheight = ANFHEIGHT; break;
    }
  if (reshape) glutReshapeWindow(aktwidth, aktheight);
  glutPostRedisplay();
}

//---Hauptprogramm---------------------------------------------

int main(int argc, char** argv)
{
   if (argc >= 1) highscorefile = argv[1];
   if (argc >= 2) vorname = argv[2];
   if (argc >= 3) nachname = argv[3]; else nachname = "RandomXmas 1.1";
   initVars();

   glutInit(&argc, argv);
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGBA | GLUT_DEPTH);
   glutInitWindowPosition (100, 100);
   glutCreateWindow ("spiel");
   init();

   glutDisplayFunc(display);
   glutReshapeFunc(DoReshape);
   glutKeyboardFunc(key);
   glutSpecialFunc(specialkey);
   glutJoystickFunc(joystickfunc, 10);
   glutReshapeWindow(aktwidth, aktheight);

   glutMainLoop();

   return 0; 
}

